#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>

static void sigusr1_handler(int sig)
{
  if (sig != SIGUSR1) {
    printf("Hey, got signal %d instead of SIGUSR1!\n", sig);
    abort();
  }
  printf("Good, SIGUSR1 caught\n");
  exit(0);
}

int main(void)
{
  sighandler_t old_sigusr1_handler;

  if (signal(SIGUSR1, sigusr1_handler) == SIG_ERR) {
    perror("Failure to register SIGUSR1 handler\n");
    return 1;
  }
  old_sigusr1_handler = signal(SIGUSR1, sigusr1_handler);
  if (old_sigusr1_handler == SIG_ERR) {
    perror("Failure to re-register SIGUSR1 handler\n");
    return 1;
  }
  else if (old_sigusr1_handler != sigusr1_handler) {
    perror("Previous SIGUSR1 handler is not sigusr1_handler\n");
    return 1;
  }
  raise(SIGUSR1);
  printf("Failure, something went wrong\n");
  abort();
}
